/*
 * Mainboart_UART_functions.c
 *
 * Created: 21.01.2014 10:18:41
 *  Author: Alex
 */ 

#include "Mainboard_UART_functions.h"


void process_rxbuf (struct circular_buffer *buf, struct config *c){
	
}

void send_ADC_raw(struct circular_buffer *buf, uint32_t adcreceive)
{
	uint8_t sendbuf;
	uint8_t ascii_convert [16] = {A_0,A_1,A_2,A_3,A_4,A_5,A_6,A_7,A_8,A_9,A,B,C,D,E,F};
	uint8_t ascii_buf=0;
	
	sendbuf = R;
	uart_TransmitByte(buf, sendbuf);
	sendbuf = A;
	uart_TransmitByte(buf, sendbuf);
	sendbuf = W;
	uart_TransmitByte(buf, sendbuf);	
	sendbuf = COL;
	uart_TransmitByte(buf, sendbuf);	
	
	ascii_buf = ((adcreceive>>20) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = ((adcreceive>>16) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = ((adcreceive>>12) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = ((adcreceive>>8) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = ((adcreceive>>4) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = (adcreceive & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);	

	// Send Carriage Return
	sendbuf = CR;
	uart_TransmitByte(buf,sendbuf);
	// Send LineFeed
	sendbuf = LF;
	uart_TransmitByte(buf,sendbuf);	
	
	};

void send_ADC_temp (struct circular_buffer *buf, uint16_t temp)
{
	// Send ASCII TimeBlock: [T|E|M|P|:|TEMPVAL(Hex,4ASCII)|CR|LF]
		uint8_t sendbuf;
		uint8_t ascii_convert [16] = {A_0,A_1,A_2,A_3,A_4,A_5,A_6,A_7,A_8,A_9,A,B,C,D,E,F};
		uint8_t ascii_buf=0;
			
		// Send Temp_Measurement
		sendbuf = T;
		uart_TransmitByte(buf, sendbuf);
		sendbuf = E;
		uart_TransmitByte(buf, sendbuf);
		sendbuf = M;
		uart_TransmitByte(buf, sendbuf);
		sendbuf = P;
		uart_TransmitByte(buf, sendbuf);
		sendbuf = COL;
		uart_TransmitByte(buf, sendbuf);
		// Send Temperature, Ascii converted
		ascii_buf = ((temp>>12) & 0x0F);
		sendbuf = ascii_convert[ascii_buf];
		uart_TransmitByte(buf,sendbuf);
		ascii_buf = ((temp>>8) & 0x0F);
		sendbuf = ascii_convert[ascii_buf];
		uart_TransmitByte(buf,sendbuf);
		ascii_buf = ((temp>>4) & 0x0F);
		sendbuf = ascii_convert[ascii_buf];
		uart_TransmitByte(buf,sendbuf);
		ascii_buf = (temp & 0x0F);
		sendbuf = ascii_convert[ascii_buf];
		uart_TransmitByte(buf,sendbuf);
		
		// Send Carriage Return
		sendbuf = CR;
		uart_TransmitByte(buf,sendbuf);
		// Send LineFeed
		sendbuf = LF;
		uart_TransmitByte(buf,sendbuf);
}

void send_ADC_data (struct circular_buffer *buf,  uint8_t active_module, uint8_t active_channel, bool Speedmode, uint16_t adc_value, uint16_t timestamp) {
	
	// Send ASCII DataBlock: [M|#|;|C|#|;|S|0/1|;|ADCVAL(Hex,4ASCII)|;| |TIMERVAL(Hex,4ASCII)|CR|LF]
	
	uint8_t ascii_convert [16] = {A_0,A_1,A_2,A_3,A_4,A_5,A_6,A_7,A_8,A_9,A,B,C,D,E,F};
	uint8_t ascii_buf=0;
	uint8_t sendbuf;
	
	// Send Active Module
	sendbuf = M;
	uart_TransmitByte(buf, sendbuf);
	// Acive Module Number
	switch (active_module)	
	{
		case 0:{
			sendbuf=A_0;	//"0"
			break;
		}
		case 1:{
			sendbuf=A_1;	//"1"
			break;
		}
		case 2:{
			sendbuf=A_2;	//"2"			
			break;
		}
		case 3:{
			sendbuf=A_3;	//"3"
			break;
		}
	}
	uart_TransmitByte(buf,sendbuf);
	
	// Send Semicolon
	sendbuf = SC;
	uart_TransmitByte(buf,sendbuf);
	
	// Send Active Channel
	sendbuf = C;			
	uart_TransmitByte(buf, sendbuf);
	// Active Channel Number
	switch (active_channel)		//Last Part of ASCII Active Channel Number
	{
		case 0:{
			sendbuf=A_0;	//"0"
			break;
		}
		case 1:{
			sendbuf=A_1;	//"1"
			break;
		}
		case 2:{
			sendbuf=A_2;	//"2"
			break;
		}
		case 3:{
			sendbuf=A_3;	//"3"
			break;
		}
	}
	uart_TransmitByte(buf,sendbuf);
	
	// Send Semicolon
	sendbuf = SC;
	uart_TransmitByte(buf,sendbuf);	
	
	// Send Speedmode True/False
	sendbuf = S;			
	uart_TransmitByte(buf, sendbuf);	
	if (Speedmode) sendbuf = A_1;		// ASCII Speedmode Bool "1"
	else sendbuf =A_0;					// ASCII Speedmode Bool "0"
	uart_TransmitByte(buf,sendbuf);
	
	// Send Semicolon
	sendbuf = SC;
	uart_TransmitByte(buf,sendbuf);	
		
	// Send ADC-Value ASCII Converted
	ascii_buf = ((adc_value>>12) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);	
	ascii_buf = ((adc_value>>8) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = ((adc_value>>4) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = (adc_value & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	
	// Send Semicolon
	sendbuf = SC;
	uart_TransmitByte(buf,sendbuf);
	
	// Send timer-Value ASCII Converted
	ascii_buf = ((timestamp>>12) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = ((timestamp>>8) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = ((timestamp>>4) & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	ascii_buf = (timestamp & 0x0F);
	sendbuf = ascii_convert[ascii_buf];
	uart_TransmitByte(buf,sendbuf);
	
	// Send Carriage Return
	sendbuf = CR;
	uart_TransmitByte(buf,sendbuf);	
	
	// Send LineFeed
	sendbuf = LF;
	uart_TransmitByte(buf,sendbuf);		
}

void Timer_init(uint16_t ctcval) {
	ctcval = 195;					// Output Compare Match with prescaler 1/1024: Every ~10ms
	PRR &= ~(1<<PRTIM1);			// Power Reduction Register: Enable Timer/Counter1
	OCR1A = ctcval;
	TCCR1B |= (1<<CS12)|(1<<CS10)|(1<<WGM12);	// Prescaler 1/1024, Clear Timer on Compare match (CTC), Mode 4
	TIMSK1 |= (1<<OCIE1A);									// Timer/Counter1 Output Compare Interrupt Request
}

void Timer_reset() {
	uint16_t val = 0;
	TCNT1 = val;
}

void Timer_disable_interrupt()
{
	TIMSK1 &= ~(1<<OCIE1A);	
}

void Timer_enable_interrupt()
{
	TIMSK1 |= (1<<OCIE1A);
}