/*
 * Mainboart_UART_functions.c
 *
 * Created: 14.01.2014 10:34:07
 *  Author: Alex
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>

#include "UART_functions.h"
#include <util/delay.h>


 void UART_Init() {
	 // baud Calculation: baud = (fosc/ 16*Baudrate)-0.5
	 // baud = (20 MHz / 16*38400)-0.5 = 32.05 --> = baud = 32
	 unsigned int baud = 32;
	 
	 //* Set baud rate */
	 UBRR0H = (unsigned char)(baud>>8);
	 UBRR0L = (unsigned char)baud;
	 /* Enable receiver and transmitter, Set Interrupts: RXCIE - RX-Complete */
	 UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0);
	 /* Set frame format: 8data, 2stop bit */
	 UCSR0C = (1<<USBS0)|(3<<UCSZ00);
 }
 
uint8_t uart_ReceiveByte( struct circular_buffer *buf ) {
	while (circbuf_isempty(buf) );	/* wait for incoming data */
	return circbuf_get(buf); /* return data */
}

void UART_disable_interrupts ()
{
	UCSR0B &= ~((1<<RXCIE0)|(1<<UDRIE0));

}

void UART_enable_interrupts()
{
	UCSR0B |= (1<<RXCIE0);

}

void uart_TransmitByte(struct circular_buffer *buf, uint8_t data ) {
	while ( circbuf_isfull(buf) );
	circbuf_add(buf,data);		/* store data in buffer */
	
	UCSR0B |= (1<<UDRIE0);			// Enable UDRIE- UART Data Register empty Interrupt - UDRE-ISR is going to put data in UDR
}



