#ifndef CIRCBUF_H_
#define CIRCBUF_H_

#include <stdbool.h>
#include <avr/interrupt.h>
#include "SPI_functions.h"
#include "UART_functions.h"
#include "Mainboard_UART_functions.h"

//circular buffer data structure
struct circular_buffer {
    char volatile *data;
    int size;
    char volatile fillcount;
    char head;
    char tail;
};

//function declarations
char circbuf_get(struct circular_buffer *buf);
void circbuf_add(struct circular_buffer *buf, char value);
bool circbuf_isempty(struct circular_buffer *buf);
bool circbuf_isfull(struct circular_buffer *buf);
void circbuf_clear(struct circular_buffer *buf);


  
#endif /*CIRCBUF_H_*/
